/////////////////////////////////////////
// John Idárraga
// For the MediPix collaboration 06/2007

#include "listHandler.h"


ListHandler::ListHandler(Char_t * dirPath){

	m_dirPath = dirPath;
	std::cout << "[INFO] looking up in " << m_dirPath << std::endl;

}

std::vector<std::string> ListHandler::OrderFilesPairMatch(std::vector<std::string> listFrames, std::vector<std::string> listDSC){


	std::vector<std::string> orderedString;

	std::vector<std::string>::iterator itFrames = listFrames.begin();
	std::vector<std::string>::iterator itDSD = listDSC.begin();

	TString tempName = "";
	TString tempName2 = "";

	for( ; itFrames != listFrames.end() ; itFrames++ )
	{
		// first possible name
		tempName = ((TString)(*itFrames));
		tempName+=".dsc";

		// second possible name
		tempName2 = ((TString)(*itFrames));
		int size = tempName2.Sizeof();
		bool marktobreak = false;
		for(int i = size-1 ; i >= 0 ; i--) {
			if(tempName2[i] == '.'){
				marktobreak = true;
			}
			// remove first
			tempName2.Remove(i);
			// then break if necessary
			if(marktobreak) break;
		}
		tempName2+=".dsc";

		/*
		if(((TString)(*itFrames)).Contains(".txt")) {
			tempName2.Remove(TString::kTrailing, 't');
			tempName2.Remove(TString::kTrailing, 'x');
			tempName2.Remove(TString::kTrailing, 't');
			tempName2.Remove(TString::kTrailing, '.');
		}
		tempName2+=".dsc";

		// third possible name
		tempName2 = ((TString)(*itFrames));
		if(((TString)(*itFrames)).Contains(".dat")) {
			tempName2.Remove(TString::kTrailing, 't');
			tempName2.Remove(TString::kTrailing, 'x');
			tempName2.Remove(TString::kTrailing, 't');
			tempName2.Remove(TString::kTrailing, '.');
		}
		tempName2+=".dsc";
		 */

		/* look for the corresponding .dsc file
	 	 that hopefully is not so far in the list.
	 	 No need to optimize this now, is fast enough.
		 */

		for(itDSD = listDSC.begin() ; itDSD != listDSC.end() ; itDSD++ ) {
			if((TString)(*itDSD) == tempName || (TString)(*itDSD) == tempName2) {
				/* get the good filename in the list and erase the entry
		 	 	   in  listDSC.  So it gets faster next time. */
				orderedString.push_back((*itDSD));
				listDSC.erase(itDSD);
				//std::cout << " !!! new size = " << listDSC.size() << std::endl;
				//std::cout << " !!! found --> " << (*itDSD) << std::endl;
				break;
			}
		}

	}

	return orderedString;
}

std::vector<std::string> ListHandler::getListToLoop(TString tempScratchDir, Int_t typeF){

	TString filename = "";
	if(tempScratchDir.Length() > 0){
		filename += tempScratchDir;
		filename += "/";
	}

	if(typeF==FRAME_FILES) filename += "listOfFiles.txt";
	if(typeF==DSC_FILES) filename += "listOfFiles.dsc.txt";

	std::string command0 = "/bin/bash -c 'rm -f "; // listOfFiles.txt"   "'";
	command0 += filename.Data();
	command0 += "'";

	std::string command02 = "/bin/bash -c 'rm -f ";
	command02 += filename.Data();
	command02 += "'";

	std::string commandn = "/bin/bash -c 'ls ";
	std::string commandn2 = "/bin/bash -c 'ls ";

	std::string command1 = "/bin/bash -c 'for a in ";
	std::string command2 = "/bin/bash -c 'for a in ";

	/* how many .dsc files do we have ? */
	commandn += m_dirPath + " | grep \".dsc\" | wc -l >> "; //listOfFiles.txt'";
	commandn += filename.Data();
	commandn += "'";

	commandn2 += m_dirPath + " | grep \".dsc\" | wc -l >> "; //listOfFiles.dsc.txt'";
	commandn2 += filename.Data();
	commandn2 += "'";

	/* get the files that are not dsc, sometimes frame data comes
     withouth extention (.txt), or can be any other */
	command1 += m_dirPath + "/* ; do [[ $a == *.dsc ]] || echo $a >> "; // listOfFiles.txt ; done'";
	command1 += filename.Data();
	command1 += " ; done'";


	/* get the files that are dsc */
	command2 += m_dirPath + "/* ; do [[ $a == *.dsc ]] && echo $a >> "; // listOfFiles.dsc.txt ; done'";
	command2 += filename.Data();
	command2 += " ; done'";

	/* get old files erased */
	if(typeF==FRAME_FILES) system(command0.c_str());
	if(typeF==DSC_FILES) system(command02.c_str());

	if(typeF==FRAME_FILES) system(commandn.c_str());
	if(typeF==DSC_FILES) system(commandn2.c_str());

	int rcm = 0, rcm2 = 0;
	if(typeF==FRAME_FILES) rcm = system(command1.c_str());
	if(typeF==DSC_FILES) rcm2 = system(command2.c_str());

	if(rcm != 0){
		std::cout << "[ERROR] unexpected error when listing files inside " << m_dirPath << std::endl;
		std::cout << "        please READ all the bash errors above. " << std::endl;
		std::cout << "        Other possible reasons: " << std::endl;
		std::cout << "        I need to make temporary files.  May be you " << std::endl;
		std::cout << "        don't have 'w' permissions in this directory ? " << std::endl;
		std::cout << "        Use the third (optional) parameter to this " << std::endl;
		std::cout << "        program to change the temp dir" << std::endl;
		exit(1);
	}

	fstream filestrList;
	filestrList.open(filename, fstream::in);

	std::string lineTemp;
	std::vector<std::string> listOfFiles;
	Int_t cntrInFile = 0;
	Int_t cntrInActualFiles = 0;
	Int_t nFiles = 0;

	while (filestrList.good())
	{
		filestrList >> lineTemp;

		if(cntrInFile == 0)
		{
			nFiles = atoi(lineTemp.c_str());
		}
		if(cntrInFile > 0 && cntrInFile <= nFiles)
		{
			//std::cout << lineTemp << std::endl;
			listOfFiles.push_back(lineTemp);
			cntrInActualFiles++;
		}
		cntrInFile++;
	}

	if(nFiles != cntrInActualFiles){
		std::cout << "[ERROR] There should be " << nFiles << " frame (and .dsc) files in this directory and I found "
				<< cntrInFile << "... giving up.";
		exit(1);
	}
	return listOfFiles;
}
